-#!/usr/bin/python
+#!/usr/bin/python3
# auto-debuild - Automatic Generation of Debian Packages
# Copyright (C) 2012 Ralf Jung <post@ralfj.de>
#
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-import os, shutil, stat, time, subprocess, sys, shlex, tempfile, argparse
+import os, shutil, stat, time, subprocess, sys, shlex, tempfile, argparse, multiprocessing
from collections import OrderedDict
# a dict with some useful additional getters which can convert types and handle one-element lists like their single member
return res
def write(self, f):
- print >>f, "#!/usr/bin/make -f"
- print >>f, ""
- print >>f, ".PHONY: build" # there may be a directory called "build"
- print >>f, ""
- print >>f, "build %:" # need to mention "build" here again explicitly so PHONY takes effect
+ print("#!/usr/bin/make -f", file=f)
+ print(file=f)
+ print(".PHONY: build", file=f) # there may be a directory called "build"
+ print(file=f)
+ print("build %:", file=f) # need to mention "build" here again explicitly so PHONY takes effect
# write proper dh call
dh = self.dh
if self.dhWith:
dh.append('--with='+','.join(self.dhWith))
- print >>f, '\t'+self.env2str()+' dh $@ '+safeCall(*dh)
+ print('\t'+self.env2str()+' dh $@ '+safeCall(*dh), file=f)
# write remaining rules
for rule in self.rules:
- print >>f, ""
- print >>f, "override_dh_"+rule+":"
+ print(file=f)
+ print("override_dh_"+rule+":", file=f)
for line in self.rules[rule]:
- print >>f, "\t"+line
+ print("\t"+line, file=f)
# rule-makers
def cmakeRules(r, config):
def getArchitecture(config):
cmd = commandInBuildEnv(config, ['dpkg-architecture', '-qDEB_HOST_ARCH'])
- p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
- res = p.communicate()[0] # get only stdout
- if p.returncode != 0: raise Exception("Querying dpkg for the architecture failed")
- return res[0:len(res)-1] # chop of the \n at the end
+ with subprocess.Popen(cmd, stdout=subprocess.PIPE) as p:
+ res = p.communicate()[0] # get only stdout
+ if p.returncode != 0: raise Exception("Querying dpkg for the architecture failed")
+ return res.decode('utf-8').strip('\n') # chop of the \n at the end
def writeDependency(f, name, list):
if len(list):
- print >>f, name+": "+', '.join(list)
+ print(name+": "+', '.join(list), file=f)
def deleteDebianFolder():
if os.path.islink('debian'):
version = config.getstr('version') # version name excluding epoch (used for filenames)
fullVersion = str(config.getint('epoch'))+':'+version if 'epoch' in config else version # version name including epoch
dbgPackage = config.getbool('dbgPackage', False)
- parallelJobs = config.getint('parallelJobs', 2)
+ parallelJobs = config.getint('parallelJobs', multiprocessing.cpu_count()+1)
packageArchitecture = config.getstr('architecture', 'any')
withPython2 = config.getbool('withPython2', False)
withSIP = config.getbool('withSIP', False)
# source format file
os.mkdir('debian/source')
with open('debian/source/format', 'w') as f:
- print >>f, "3.0 (native)"
+ print("3.0 (native)", file=f)
# compat file
with open('debian/compat', 'w') as f:
- print >>f, "9"
+ print("9", file=f)
# copyright file
with open('debian/copyright', 'w') as f:
- print >>f, "Auto-generated by auto-debuild, not suited for distribution"
+ print("Auto-generated by auto-debuild, not suited for distribution", file=f)
# changelog file
with open('debian/changelog', 'w') as f:
- print >>f, sourceName,"("+fullVersion+")","UNRELEASED; urgency=low"
- print >>f, ""
- print >>f, " * Auto-generated by auto-debuild"
- print >>f, ""
- print >>f, " --",name,"<"+email+"> "+time.strftime('%a, %d %b %Y %H:%M:%S %z')
+ print(sourceName,"("+fullVersion+")","UNRELEASED; urgency=low", file=f)
+ print(file=f)
+ print(" * Auto-generated by auto-debuild", file=f)
+ print(file=f)
+ print(" --",name,"<"+email+"> "+time.strftime('%a, %d %b %Y %H:%M:%S %z'), file=f)
# control file
with open('debian/control', 'w') as f:
# source package
- print >>f, "Source:",sourceName
- print >>f, "Section:",config.getstr('section', 'misc')
- print >>f, "Priority: extra"
- print >>f, "Maintainer: %s <%s>" % (name, email)
+ print("Source:",sourceName, file=f)
+ print("Section:",config.getstr('section', 'misc'), file=f)
+ print("Priority: extra", file=f)
+ print("Maintainer: %s <%s>" % (name, email), file=f)
writeDependency(f, 'Build-Depends', ["debhelper (>= 9)"] + buildSystem.buildDepends + config.get('buildDepends', []))
- print >>f, "Standards-Version: 3.9.3"
+ print("Standards-Version: 3.9.3", file=f)
# main binary package
- print >>f, ""
- print >>f, "Package:",binaryName
- print >>f, "Architecture:",packageArchitecture
+ print(file=f)
+ print("Package:",binaryName, file=f)
+ print("Architecture:",packageArchitecture, file=f)
if 'binaryMultiArch' in config:
- print >>f, "Multi-Arch:",config.getstr('binaryMultiArch')
+ print("Multi-Arch:",config.getstr('binaryMultiArch'), file=f)
writeDependency(f, "Pre-Depends", ["${misc:Pre-Depends}"] + config.get('binaryPreDepends', []))
writeDependency(f, "Depends", ["${shlibs:Depends}", "${misc:Depends}"] + buildSystem.binaryDepends +
config.get('binaryDepends', []))
writeDependency(f, "Conflicts", config.get('binaryConflicts', []))
writeDependency(f, "Breaks", config.get('binaryBreaks', []) + config.get('binaryBreaksReplaces', []))
writeDependency(f, "Replaces", config.get('binaryReplaces', []) + config.get('binaryBreaksReplaces', []))
- print >>f, "Description:",sourceName,"(auto-debuild)"
- print >>f, " Package auto-generated by auto-debuild."
+ print("Description:",sourceName,"(auto-debuild)", file=f)
+ print(" Package auto-generated by auto-debuild.", file=f)
files.append(os.path.join(debDir, "%s_%s_%s.deb" % (binaryName, version, arch)))
# debug package
if dbgPackage:
- print >>f, ""
- print >>f, "Package:",binaryName+"-dbg"
- print >>f, "Section: debug"
- print >>f, "Priority: extra"
- print >>f, "Architecture:",packageArchitecture
+ print(file=f)
+ print("Package:",binaryName+"-dbg", file=f)
+ print("Section: debug", file=f)
+ print("Priority: extra", file=f)
+ print("Architecture:",packageArchitecture, file=f)
writeDependency(f, "Depends", ["${misc:Depends}", binaryName+" (= ${binary:Version})"])
- print >>f, "Description:",sourceName,"debug smbols (auto-debuild)"
- print >>f, " Package containing debug symbols for "+sourceName+", auto-generated by auto-debuild."
+ print("Description:",sourceName,"debug smbols (auto-debuild)", file=f)
+ print(" Package containing debug symbols for "+sourceName+", auto-generated by auto-debuild.", file=f)
files.append(os.path.join(debDir, "%s-dbg_%s_%s.deb" % (binaryName, version, arch)))
# shim packages
for shim in config.get('binaryShims', []):
- print >>f, ""
- print >>f, "Package:",shim
- print >>f, "Section:",config.getstr('section', 'misc')
- print >>f, "Priority: extra"
- print >>f, "Architecture:",packageArchitecture
+ print(file=f)
+ print("Package:",shim, file=f)
+ print("Section:",config.getstr('section', 'misc'), file=f)
+ print("Priority: extra", file=f)
+ print("Architecture:",packageArchitecture, file=f)
writeDependency(f, "Depends", ["${misc:Depends}", binaryName+" (= ${binary:Version})"])
- print >>f, "Description:",sourceName,"shim for",shim,"(auto-debuild)"
- print >>f, " Package pretending to be "+shim+", auto-generated by auto-debuild."
+ print("Description:",sourceName,"shim for",shim,"(auto-debuild)", file=f)
+ print(" Package pretending to be "+shim+", auto-generated by auto-debuild.", file=f)
files.append(os.path.join(debDir, "%s_%s_%s.deb" % (shim, version, arch)))
# install file
with open('debian/'+binaryName+'.install', 'w') as f:
for line in config.get('binaryInstallFiles', []):
if line.startswith('/'): # a file from within the package, not from the source tree
line = 'debian/'+binaryName+line
- print >>f, line
+ print(line, file=f)
# maintainer scripts for alternatives
if 'alternatives' in config:
with open('debian/'+binaryName+'.postinst', 'w') as f:
- print >>f, "#!/bin/sh"
- print >>f, "set -e"
- print >>f, 'if [ "$1" = "configure" ]; then'
+ print("#!/bin/sh", file=f)
+ print("set -e", file=f)
+ print('if [ "$1" = "configure" ]; then', file=f)
for alternative in config.get('alternatives'):
alternative = shlex.split(alternative)
- print >>f, safeCall('update-alternatives', '--install', alternative[0], alternative[1], alternative[2], alternative[3])
- print >>f, 'fi'
- print >>f, ''
- print >>f, '#DEBHELPER#'
- print >>f, ''
- print >>f, 'exit 0'
+ print(safeCall('update-alternatives', '--install', alternative[0], alternative[1], alternative[2], alternative[3]), file=f)
+ print('fi', file=f)
+ print(file=f)
+ print('#DEBHELPER#', file=f)
+ print(file=f)
+ print('exit 0', file=f)
with open('debian/'+binaryName+'.prerm', 'w') as f:
- print >>f, "#!/bin/sh"
- print >>f, "set -e"
- print >>f, 'if [ "$1" = "remove" ]; then'
+ print("#!/bin/sh", file=f)
+ print("set -e", file=f)
+ print('if [ "$1" = "remove" ]; then', file=f)
for alternative in config.get('alternatives'):
alternative = shlex.split(alternative)
- print >>f, safeCall('update-alternatives', '--remove', alternative[1], alternative[2])
- print >>f, 'fi'
- print >>f, ''
- print >>f, '#DEBHELPER#'
- print >>f, ''
- print >>f, 'exit 0'
+ print(safeCall('update-alternatives', '--remove', alternative[1], alternative[2]), file=f)
+ print('fi', file=f)
+ print(file=f)
+ print('#DEBHELPER#', file=f)
+ print(file=f)
+ print('exit 0', file=f)
# rules file: build system specific
with open('debian/rules', 'w') as f:
# pre-fill rule file with our global defaults
config['waitAfterConfig'] = args.wait_after_config
# generate debian files
if os.path.exists('debian') or os.path.islink('debian'):
- if raw_input("A debian folder already exists, do you want to remove it and whatever it links to (y/N)? ").lower() != "y":
+ if input("A debian folder already exists, do you want to remove it and whatever it links to (y/N)? ").lower() != "y":
sys.exit(1)
deleteDebianFolder()
files = createDebianFiles(config)
# check if a file is overwritten
for file in files:
if os.path.exists(file):
- if raw_input("Do you want to overwrite %s (y/N)? " % file).lower() != "y":
+ if input("Do you want to overwrite %s (y/N)? " % file).lower() != "y":
sys.exit(1)
# run compilation
buildDebianPackage(config)
# install files
- print "Installing created deb files..."
+ print("Installing created deb files...")
subprocess.check_call(['sudo', 'dpkg', '--install'] + files)
except (subprocess.CalledProcessError, KeyboardInterrupt) as e: # for some exceptions, a stackrace is usually pointless
- print >> sys.stderr
- print >> sys.stderr
+ print(file=sys.stderr)
+ print(file=sys.stderr)
if isinstance(e, KeyboardInterrupt): # str(e) would be the empty string
- print >> sys.stderr, "Interruped by user"
+ print("Interruped by user", file=sys.stderr)
else:
- print >> sys.stderr, "Error during package creation: %s" % str(e)
- print >> sys.stderr
+ print("Error during package creation: %s" % str(e), file=sys.stderr)
+ print(file=sys.stderr)
sys.exit(1)